## drbl-installer 1.04-1

=== Makefile ===
all: clean
	cp drblsrv/makeit .
	. makeit
	cp drblpush/makeit .
	. makeit
	rm -f makeit

install: all
	install -m 755 build/drblpush $(INSTPATH)/sbin
	install -m 755 build/drblsrv $(INSTPATH)/sbin

clean:
	rm -rf build

apt:
	dpkg-buildpackage
	scp ../drbl-installer* klhaung@os.nchc.org.tw:~/drbl/debian/apt/sarge/drbl/installer
	scp ../drbl-installer* klhaung@os.nchc.org.tw:~/drbl/debian/apt/woody/drbl/installer
	rm ../drbl-installer*
	debian/rules clean

apt-test:
	dpkg-buildpackage
	scp ../drbl-installer* klhaung@os.nchc.org.tw:~/drbl/debian/apt/repository-test/installer
	scp ../drbl-installer* klhaung@os.nchc.org.tw:~/drbl/debian/apt/repository-test/installer
	rm ../drbl-installer*
	debian/rules clean

=== drblcd/Makefile ===

all: clean
	./make-livecd

no_bootstrap: clean
	./make-livecd --no_bootstrap

non_interactive:
	./make-livecd --non_interactive drbl

clean:
	rm -f setupx.tar
	rm -f setupx.tar.gz
	rm -f cdimage.iso
	rm -rf setupx
	rm -rf drbl.tar.gz
	rm -f *.iso
	rm -f *.md5sum

=== drblpush/freedos/Makefile ===
FDOS_VERSION = beta9rc2
FDOS_IMAGE = boot1440.img
FDOS_SOURCE = http://www.ibiblio.org/pub/micro/pc-stuff/freedos/files/distributions/$(FDOS_VERSION)/diskimg/$(FDOS_IMAGE)

all: fdos memtest

fdos : $(FDOS_IMAGE)
	./make_fdos.sh

memtest :

clean:
	rm -f *.img
	rm -f *.nbi

# download the file if needed
$(FDOS_IMAGE) :
	[ -f $(FDOS_IMAGE) ] || wget $(FDOS_SOURCE) || true

=== drblpush/mkinitrd-net/Makefile ===
UCLIBC_VERSION = 0.9.16
UCLIBC = uClibc-$(UCLIBC_VERSION)
$(UCLIBC)_SOURCE = http://www.uclibc.org/downloads/$(UCLIBC).tar.bz2
UCLIBC_INSTALL = $(CURDIR)/uClibc

UDHCP_VERSION = 0.9.8
UDHCP = udhcp-$(UDHCP_VERSION)
$(UDHCP)_SOURCE = http://udhcp.busybox.net/source/$(UDHCP).tar.gz

BUSYBOX_VERSION = 0.60.3
BUSYBOX = busybox-$(BUSYBOX_VERSION)
$(BUSYBOX)_SOURCE = http://www.busybox.net/downloads/$(BUSYBOX).tar.bz2

LINUX_WLAN_VERSION = 0.1.13
LINUX_WLAN = linux-wlan-ng-$(LINUX_WLAN_VERSION)
$(LINUX_WLAN)_SOURCE = ftp://ftp.linux-wlan.org/pub/linux-wlan-ng/$(LINUX_WLAN).tar.gz

MKNBI_VERSION = 1.2
MKNBI = mknbi-$(MKNBI_VERSION)
$(MKNBI)_SOURCE = http://belnet.dl.sourceforge.net/sourceforge/etherboot/$(MKNBI).tar.gz

export PATH := $(UCLIBC_INSTALL)/bin:$(PATH)

KVER = 2.4.22-xfs

# marked by Blake Kuo-Lien Huang
#all : utils initrd-skel mknbi mknbi-linux
all: utils initrd-skel
	# Run "make tftpboot/initrd-kernel_module.img" to generate a suitable initrd
	# Run "make tftpboot/boot-kernel_module.nbi" to generate a suitable NBI
	# Run "make all-nbi" to generate a complete set of NBIs

%.tar.bz2 :
	[ -d $* ] || wget $($*_SOURCE)
	[ -f $*.t*gz ] && ( gunzip $*.t*gz ; bzip2 -9 $*.tar ) || true

#UTILS = udhcpc busybox wlanctl
UTILS = udhcpc busybox

utils : $(UTILS)

clean : partlyclean
	rm -rf uClibc
	rm -rf $(UCLIBC)
	rm -rf tftpboot/*

partlyclean :
	rm -rf $(UDHCP)
	rm -rf $(BUSYBOX)
	rm -rf $(LINUX_WLAN)
	rm -rf $(MKNBI)
	rm -rf initrd-skel
	rm -f *.img *.ird *.nbi insert-modules
	rm -f $(UTILS) mknbi-linux
	rm -f *.uClibc *.busybox *.udhcpc *.wlanctl

.PHONY : all utils clean partlyclean

uClibc : $(UCLIBC)
	rm -rf $@
	$(MAKE) -C $(UCLIBC) install

$(UCLIBC) : $(UCLIBC).tar.bz2
	[ -d $@ ] || tar xvjf $<
	# Stripping out spurious CVS directories (screws up local cvs update)
	rm -rf `find $(UCLIBC) -name CVS`
	# for DRBL, modified by Steven Shiau.
	cd $(UCLIBC);$(MAKE) defconfig; $(MAKE)
	install -m 644 $(UCLIBC)/COPYING.LIB COPYING.uClibc

udhcpc : $(UDHCP)
	install -m 755 -s $(UDHCP)/$@ $@

# marked by Blake, Kuo-Lien Huang
#$(UDHCP) : $(UDHCP).tar.bz2 uClibc
$(UDHCP) : $(UDHCP).tar.bz2
	[ -d $@ ] || tar xvjf $<
	if [ ! -f $@/.script.c.patch ]; then \
		patch -d $@ -b -z .orig < script.c.patch ; \
		touch $@/.script.c.patch ; \
	fi
	$(MAKE) LDFLAGS+=-static -C $(UDHCP)
	install -m 644 $(UDHCP)/AUTHORS AUTHORS.udhcpc
	install -m 644 $(UDHCP)/COPYING COPYING.udhcpc

busybox : $(BUSYBOX)
	install -m 755 -s $(BUSYBOX)/$@ $@

# marked by Blake, Kuo-Lien Huang
#$(BUSYBOX) : $(BUSYBOX).tar.bz2 uClibc
$(BUSYBOX) : $(BUSYBOX).tar.bz2
	[ -d $@ ] || tar xvjf $<
	perl -pi.orig -e \
	  's/^.*(#define BB_(FEATURE_NFSMOUNT|INSMOD|PIVOT_ROOT|IFCONFIG|ROUTE|PING|EXPR)).*/$$1/' \
	  $(BUSYBOX)/Config.h
	perl -pi.orig -e \
	  's/^(DOSTATIC).*$$/$$1 = true/' \
	  $(BUSYBOX)/Makefile
	$(MAKE) -C $(BUSYBOX)
	install -m 644 $(BUSYBOX)/AUTHORS AUTHORS.busybox
	install -m 644 $(BUSYBOX)/LICENSE LICENSE.busybox

wlanctl : $(LINUX_WLAN)
	install -m 755 -s $(LINUX_WLAN)/src/wlanctl/$@ $@

$(LINUX_WLAN) : $(LINUX_WLAN).tar.bz2 uClibc linux-wlan.cfg
	[ -d $@ ] || tar xvjf $<
	cd $(LINUX_WLAN) ; ./Configure -d ../linux-wlan.cfg
	perl -pi.orig -e \
	  's/(-o wlanctl)/-static $$1/' \
	  $(LINUX_WLAN)/src/wlanctl/Makefile
	$(MAKE) -C $(LINUX_WLAN)/src/wlanctl
	install -m 644 $(LINUX_WLAN)/COPYING COPYING.wlanctl
	install -m 644 $(LINUX_WLAN)/LICENSE LICENSE.wlanctl
	install -m 644 $(LINUX_WLAN)/THANKS THANKS.wlanctl

mknbi-linux : $(MKNBI)

mknbi : $(MKNBI)

$(MKNBI) : $(MKNBI).tar.bz2
	[ -d $@ ] || tar xvjf $<
	if [ ! -f $@/.mknbi-encap.patch ]; then \
		patch -d $@ -b -z .orig < mknbi-encap.patch ; \
		touch $@/.mknbi-encap.patch ; \
	fi
	make -C $(MKNBI) LIBDIR=`pwd`/$(MKNBI) mknbi
	install -m 755 $(MKNBI)/mknbi mknbi-linux
	make -C $(MKNBI) clean
	make -C $(MKNBI)

drblhost: drblhost.c
	$(CC) -static -o $@ $<

initrd-skel : $(UTILS) linuxrc udhcpc-post drblhost include-modules
	rm -rf $@
	mkdir -p $@
	mkdir -p $@/dev
	mkdir -p $@/etc
	mkdir -p $@/bin
	mkdir -p $@/lib
	mkdir -p $@/lib/modules
	mkdir -p $@/proc
	mkdir -p $@/sysroot
	ln -s bin $@/sbin
	install -m 755 busybox $@/bin/
	install -m 755 udhcpc $@/bin/
#	install -m 755 wlanctl $@/bin/
	ln -s busybox $@/bin/sh
	ln -s busybox $@/bin/echo
	ln -s busybox $@/bin/mknod
	ln -s busybox $@/bin/chmod
	ln -s busybox $@/bin/insmod
	ln -s busybox $@/bin/ifconfig
	ln -s busybox $@/bin/route
	ln -s busybox $@/bin/mount
	ln -s busybox $@/bin/pivot_root
	ln -s busybox $@/bin/umount
	ln -s busybox $@/bin/[
	ln -s busybox $@/bin/sleep
	ln -s busybox $@/bin/grep
	# for DRBL, modified by Steven Shiau
	ln -s busybox $@/bin/sed
	ln -s busybox $@/bin/cat
	ln -s busybox $@/bin/cut
	ln -s busybox $@/bin/ping
	ln -s busybox $@/bin/ls
	ln -s busybox $@/bin/reboot
	ln -s busybox $@/bin/expr

	install -m 755 linuxrc $@/linuxrc
	install -m 755 udhcpc-post $@/bin/udhcpc-post
	install -m 755 drblhost $@/bin/drblhost

tftpboot/initrd-%.img : initrd-skel
	./mkinitrd-net -l `echo $* | tr . " "`

tftpboot/boot-%.nbi : tftpboot/initrd-%.img mknbi-linux
	./mknbi-linux --format=nbi --target=linux /boot/vmlinuz $< > $@
	sudo cp $@ $(tftpbootdir)

all-nbi : all
#	./mknbi-set -l -v -k vmlinuz-2.4.18
#	./mknbi-set -l -v -k vmlinuz-2.4.20
	./mknbi-set -l -v -k vmlinuz-$(KVER)
	ls tftpboot

# add by Blake, Kuo-Lien Huang
drbl-all-nbi: utils initrd-skel
#	./mknbi-set --drbl -v -k vmlinuz-2.4.18
#	./pxe_pciscan.sh --drbl --kernel 2.4.18
#	./mknbi-set --drbl -v -k vmlinuz-2.4.20
#	./pxe_pciscan.sh --drbl --kernel 2.4.20
	./mknbi-set --drbl -v -k vmlinuz-$(KVER)
	./pxe_pciscan.sh --drbl --kernel $(KVER)
#	ls tftpboot

prefix = /usr
sysconfdir = /etc
bindir = $(prefix)/bin
libdir = $(prefix)/lib
mandir = $(prefix)/share/man
docdir = $(prefix)/share/doc
# for DRBL, Steven Shiau modified
#tftpbootdir = /var/lib/tftpboot
tftpbootdir = /tftpboot
initrdskeldir = $(prefix)/lib/mkinitrd-net/initrd-skel

install :
	mkdir -p $(libdir)/mknbi
	mkdir -p $(bindir)
	mkdir -p $(sysconfdir)
	mkdir -p $(tftpbootdir)
	mkdir -p $(initrdskeldir)
	install -m 755 mkinitrd-net include-modules mknbi-set $(bindir)/
	cp -a initrd-skel/* $(initrdskeldir)/
	install -m 644 mknbi-set.conf dhcpd.conf.etherboot.include $(sysconfdir)
	make -C $(MKNBI) INSTPREFIX=$(prefix) MANDIR=$(mandir)/man1 \
		DOCDIR=$(docdir)/$(MKNBI) install

=== drblpush/packet/Makefile ===

CC=gcc

.SUFFIXES:
.SUFFIXES: .c .o

all: packet

packet: packet.o
	$(CC) -o packet -lpcap -lpthread $? 

install: packet
	mv packet ../detect_mac

clean:
	rm -rf *.o
	rm -rf packet

.c.o:
	$(CC) -c -o $@ $<

=== misc/module/Makefile ===

CC=/usr/bin/gcc
MOD_OBJS=main.o proc.o net.o

all: ${MOD_OBJS}
	ld -r ${MOD_OBJS} -o drbl.o

install: ${MOD_OBJS}
	install -m 644 drbl.o /lib/modules/misc

clean:
	rm -f *.o

.c.o:
	${CC} -O2 -D__KERNEL__ -DMODULE -I/usr/src/linux/include -c $<

=== debian/changelog ===
drbl-installer (1.04-1) unstable; urgency=low

  * use shore name 'drblsrv' and 'drblpush' instead of 'drblsrv-desktop' and 'drblpush-desktop'
  * use drblsrv for server's configuration which combine original drblsrv-desktop and drblcli-desktop
  * sync 4-step and 2-step installation

 -- Blake,Kuo-Lien Huang <klhaung@nchc.org.tw>  Wed, 11 Aug 2004 13:35:04 +0800

drbl-installer (1.03) unstable; urgency=low

  * 1.02 patch 1 ~ 6
  * installation on SCSI hd

 -- Blake,Kuo-Lien Huang <klhaung@nchc.org.tw>  Tue, 04 May 2004 09:37:29 +0800

drbl-installer (1.02) unstable; urgency=low

  * drblsrv: use drblsrv-desktop to install DRBL
  * drblcli: use drblcli-desktop to install DRBL
  * drblpush: allow multiple kernel version

 -- Blake,Kuo-Lien Huang <klhaung@nchc.org.tw>  Thu, 19 Feb 2004 13:04:21 +0800

drbl-installer (1.01) unstable; urgency=low

  * drblpush: client switch for multicast clonezilla
  * drblcli: setupx monitor resolution problem

 -- Blake,Kuo-Lien Huang <klhaung@nchc.org.tw>  Sun, 23 Nov 2003 14:18:25 +0800

drbl-installer (1.0) unstable; urgency=low

  * Initial Release.

 -- Blake,Kuo-Lien Huang <klhaung@nchc.org.tw>  Sun, 23 Nov 2003 14:18:25 +0800

=== debian/control ===
Source: drbl-installer
Section: drbl
Priority: optional
Maintainer: Blake,Kuo-Lien Huang <klhaung@nchc.org.tw>
Build-Depends: debhelper (>> 3.0.0)
Standards-Version: 3.5.2

Package: drbl-installer
Architecture: any
Depends: ${shlibs:Depends}
Description: installer for DRBL
 drblsrv: install and setup needed packages on DRBL server 
 drblpush: configure DRBL clients

=== debian/rules ===
#!/usr/bin/make -f
# Sample debian/rules that uses debhelper.
# GNU copyright 1997 to 1999 by Joey Hess.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

# This is the debhelper compatibility version to use.
export DH_COMPAT=3

ifneq (,$(findstring debug,$(DEB_BUILD_OPTIONS)))
	CFLAGS += -g
endif
ifeq (,$(findstring nostrip,$(DEB_BUILD_OPTIONS)))
	INSTALL_PROGRAM += -s
endif

configure: configure-stamp
configure-stamp:
	dh_testdir
	touch configure-stamp


build: build-stamp

build-stamp: configure-stamp 
	dh_testdir
	touch build-stamp

clean:
	dh_testdir
	dh_testroot
	rm -f build-stamp configure-stamp
	dh_clean
	make clean
	rm -rf debian/drbl-installer

install: build
	dh_testdir
	dh_testroot
	dh_clean -k
	dh_installdirs

	# Add here commands to install the package into debian/drbl-installer.
	install -d -m 755 $(CURDIR)/debian/drbl-installer/opt/drbl/sbin
	make install INSTPATH=$(CURDIR)/debian/drbl-installer/opt/drbl

# Build architecture-independent files here.
binary-indep: build install
# We have nothing to do by default.

# Build architecture-dependent files here.
binary-arch: build install
	dh_testdir
	dh_testroot
#	dh_installdebconf	
	dh_installdocs
	dh_installexamples
	dh_installmenu
#	dh_installlogrotate
#	dh_installemacsen
#	dh_installpam
#	dh_installmime
#	dh_installinit
	dh_installcron
	dh_installman
	dh_installinfo
#	dh_undocumented
	dh_installchangelogs 
	dh_link
	dh_strip
	dh_compress
	dh_fixperms
#	dh_makeshlibs
	dh_installdeb
#	dh_perl
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install configure
